
CREATE OR REPLACE FUNCTION tcg.public.FN_before_insert_TCG_MTG_Game_Player()
RETURNS TRIGGER AS $$
DECLARE
    r_change_set RECORD;
BEGIN
    NEW.created_on = COALESCE(NEW.created_on, CURRENT_TIMESTAMP);
    NEW.updated_last_on = COALESCE(NEW.updated_last_on, CURRENT_TIMESTAMP);

    IF NEW.change_set_id IS NULL THEN
		RAISE EXCEPTION 'Change Set ID must be provided.';
    END IF;

    SELECT *
    INTO r_change_set
    FROM tcg.public.TCG_Change_Set CHANGE_SET
    WHERE NEW.change_set_id = CHANGE_SET.change_set_id
    ;

    IF FOUND THEN
        NEW.created_by_user_id := COALESCE(NEW.created_by_user_id, r_change_set.updated_last_by_user_id);
        NEW.updated_last_by_user_id := COALESCE(NEW.updated_last_by_user_id, r_change_set.updated_last_by_user_id);
        NEW.created_on := COALESCE(NEW.created_on, r_change_set.updated_last_on);
    ELSE
        RAISE EXCEPTION 'Change Set % not found.', NEW.change_set_id;
    END IF;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql
;

CREATE OR REPLACE FUNCTION tcg.public.FN_before_update_TCG_MTG_Game_Player()
RETURNS TRIGGER AS $$
BEGIN
    NEW.updated_last_on = CURRENT_TIMESTAMP;

    IF OLD.change_set_id IS NOT DISTINCT FROM NEW.change_set_id THEN
		RAISE EXCEPTION 'New Change Set ID must be provided.';
    END IF;

    INSERT INTO tcg.public.TCG_MTG_Game_Player_Audit (
		  player_id
        , name_field
        , value_prev
        , value_new
        , change_set_id
    )
	-- Changed game_id
	SELECT NEW.player_id, 'game_id', OLD.game_id::TEXT, NEW.game_id::TEXT, NEW.change_set_id
		WHERE OLD.game_id IS DISTINCT FROM NEW.game_id
	UNION
	-- Changed user_id
	SELECT NEW.player_id, 'user_id', OLD.user_id::TEXT, NEW.user_id::TEXT, NEW.change_set_id
		WHERE OLD.user_id IS DISTINCT FROM NEW.user_id
	UNION
	-- Changed deck_id
	SELECT NEW.player_id, 'deck_id', OLD.deck_id::TEXT, NEW.deck_id::TEXT, NEW.change_set_id
		WHERE OLD.deck_id IS DISTINCT FROM NEW.deck_id
	UNION
	-- Changed name
	SELECT NEW.player_id, 'name', OLD.name, NEW.name, NEW.change_set_id
		WHERE OLD.name IS DISTINCT FROM NEW.name
	UNION
	-- Changed notes
	SELECT NEW.player_id, 'notes', OLD.notes, NEW.notes, NEW.change_set_id
		WHERE OLD.notes IS DISTINCT FROM NEW.notes
	UNION
	-- Changed display_order
	SELECT NEW.player_id, 'display_order', OLD.display_order::TEXT, NEW.display_order::TEXT, NEW.change_set_id
		WHERE OLD.display_order IS DISTINCT FROM NEW.display_order
	UNION
	-- Changed active
	SELECT NEW.player_id, 'active', OLD.active::TEXT, NEW.active::TEXT, NEW.change_set_id
		WHERE OLD.active IS DISTINCT FROM NEW.active
    ;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql
;

CREATE TRIGGER TRI_before_insert_TCG_MTG_Game_Player
    BEFORE INSERT ON tcg.public.TCG_MTG_Game_Player
    FOR EACH ROW
    EXECUTE FUNCTION tcg.public.FN_before_insert_TCG_MTG_Game_Player()
;
CREATE TRIGGER TRI_before_update_TCG_MTG_Game_Player
    BEFORE UPDATE ON tcg.public.TCG_MTG_Game_Player
    FOR EACH ROW
    EXECUTE FUNCTION tcg.public.FN_before_update_TCG_MTG_Game_Player()
;